/*******************************************************************************
 Autor: Ulli Sommer
 PRO-BOT128 mit CMU-CAM 2 oder 2
 PRO-BOT128 besitzt Servos als Antrieb
 Daruch lsst sich das Objekt prziser anfahren!
*******************************************************************************/

byte Buffer[146];
int Cam_Data, Turn_delay;

void main(void)
{

    //Initialisierung
    PRO_BOT128_INIT();

    //ACS setup Empfindlichkeit einstellbar von 1 To 20 / 1=nach / 20=fern
    ACS_INIT(3);

    //Tonfolge
    BEEP(250,200);
    BEEP(150,150);
    BEEP(250,200);

    //Warten bis Taster SW2 gedrcket wurde. SW2 = Programmstart
    do
    {
    }while(SW2!=1);

    BEEP(200,100);
    DELAY_MS(1000);

    //Antrieb einschalten
    DRIVE_ON();

    //Objekt Tracking
    do
    {

      //Aktuelle Daten von der Kamera holen
      Cam_Data=KAMERA();


      //Das Objekt ist links
      if((Cam_Data<40)&&(Cam_Data>1))
      {

        /*
        Liegt das Objekt sehr weit links, soll der Roboter sich eine
        lngere Zeit drehen, als wenn das Objekt nicht so weit links
        liegt. ber die Variable "Drehwert" wird die Dauer festgelgt,
        mit der sich der Roboter dreht. ber Rckgabewert der Kamerafunktion
        kann man auch sehen, wie weit links sich das Objekt befindet.
        Ist der Wert z.B. 1, so ist das Objekt ganz am Rande des
        Kamerablickfeldes. Ist der Wert 43, so ist das Objekt schon fast
        in der Mitte.
        */

        Turn_delay=(44-Cam_Data)*10;

        /*
        Anschlieend wird noch mit 10 multipliziert. Dies ist ein Erfahungswert.
        Wird der Wert zu niedrig gewhlt, dreht sich der Roboter nicht lange
        genug. Wird er zu hoch gewhlt, dreht er sich zu lange. Der
        Roboter dreht sich dann am Objekt vorbei.
        */

        //nach links drehen
        FLL_ON();
        FLR_OFF();
        DRIVE(128,170);
        DELAY_MS(Turn_delay);

      }

      //Das Objekt ist rechts

      else if((Cam_Data>50)&&(Cam_Data<89))
      {

        //Hier passiert das selbe wie oben
        Turn_delay=(Cam_Data-44)*10;

        //nach rechts drehen
        FLL_OFF();
        FLR_ON();
        DRIVE(170,128);
        DELAY_MS(Turn_delay);
      }

      //Super! Das Objekt liegt in der Mitte

      else if((Cam_Data>=40)&&(Cam_Data<=50))
      {
        //Nun wo das Objekt zentriert ist, kann nach der Entfernung des Objekts gefragt
        //werden. Daher wird nun das ACS-System abgefragt.

        //Sind wir schon da? --> Ja: Antrieb stoppen - Tonfolge - verlassen
        if((ACS_LEFT()==0)&&(ACS_RIGHT()==0))
        {
          //Antrieb stoppen
          DRIVE(128,128);
          DRIVE_OFF();

          //Tonfolge
          BEEP(150,500);
          BEEP(150,500);
          BEEP(250,300);
          break;
        }

        //geradeaus fahren
        FLL_ON();
        FLR_ON();
        DRIVE(200,200);
        DELAY_MS(250);
      }

      else

        //kein Objekt erkannt? --> Objekt suchen
        //rechts drehen bis Objekt sichtbar
        FLL_OFF();
        FLR_OFF();
        DRIVE(170,90);

    }while(1);

}
