/*******************************************************************************
 Autor: Ulli Sommer
 ACS (Anti Collisions System) mit Multithreading
 Die Ausweichroutine ist so gestalltet, das ein festfahren
 in Ecken "fast" unmglich ist.
*******************************************************************************/

byte ACS_l, ACS_r, Drehung, Vorwaerts;

void main(void)
{

    PRO_BOT128_INIT();                  //PRO-BOT128 Initialisieren
    DRIVE_ON();                         //Motor Treiber einschalten
    ENC_LED_ON();                       //Encoder IR LEDs einschalten
    ACS_INIT(10);                       //ACS setup / Sensity 1 To 20

    Thread_Delay(100);                  //1Sek. Pause
    BEEP(150,300);                      //Tonfolge
    BEEP(250,250);
    BEEP(150,300);

    ACS_r=1;                            //Werte auf vorwrts
    ACS_l=1;
    Vorwaerts=0;

    Thread_Start(1,Thread_ACS);         //Threads starten
    Thread_Start(2,Thread_Drive);

    //Hauptprogramm
    do
    {
        //Akku Unterspannungsberwachung
        if(AKKU_SPG()<4.0)
        {
           Thread_Delay(100);
           if(AKKU_SPG()<3.8)
           {
              Thread_Kill(1);
              Thread_Kill(2);
              DRIVE_OFF();
              ENC_LED_OFF();

              do
              {
                 BEEP(150,100);
                 Thread_Delay(100);
              }while(1);

           }
        }

    }while(1);

}


//Thread 1
void Thread_ACS(void)
{
    do
    {
      //ACS permanent einlesen
      ACS_l=ACS_LEFT();
      Thread_Delay(1);    //100ms
      ACS_r=ACS_RIGHT();
      Thread_Delay(1);
    }while(1);

}


//Thread 2
void Thread_Drive(void)
{
    do
    {

       //Autonom umherfahren und dabei Hindernisse ausweichen

       //vorwrts
       if((ACS_l==1)&&(ACS_r==1))
       {
          Vorwaerts++;
          if(Vorwaerts>20)Drehung=0;
          FLL_OFF();
          FLR_OFF();
          DRIVE_FWD(150,1);
       }

       //rckwrts
       if((ACS_l==0)&&(ACS_r==0))
       {
          FLL_ON();
          FLR_ON();
          DRIVE_BWD(140,10);
          TURN_LEFT(135,3+Drehung);
       }

       //links drehen
       if((ACS_l==1)&&(ACS_r==0))
       {
          Drehung++;
          FLL_OFF();
          FLR_ON();
          TURN_LEFT(135,3+Drehung);
       }

       //rechts drehen
       if((ACS_l==0)&&(ACS_r==1))
       {
          Drehung++;
          FLL_ON();
          FLR_OFF();
          TURN_RIGHT(135,3+Drehung);
       }

    }while(1);

}

