﻿Option Strict Off
Option Explicit On

Imports System
Imports System.Windows.Forms
Imports System.Text.Encoding
Imports System.IO.Ports.SerialPort

Public Class Form1

    'Comports
    Public ports As String() = GetPortNames()
    Public port As String = ""
    Declare Sub Beep Lib "kernel32.dll" (ByVal tone As Integer, ByVal dauer As Integer)

    'Sleep Funktion in ms
    Declare Sub Sleep Lib "kernel32.dll" (ByVal dwMilliseconds As Long)

    'Empfangs Buffer für die RS232
    Dim Buffer As String

    'Sende Variablen
    Dim Addr As Byte
    Dim Command1 As Byte
    Dim Command2 As Byte
    Dim CRC As Byte
    Dim Speed As Byte
    Dim Status_RX As Byte

    'Roboter Adresse
    Const Robo_Addr = 255

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged

        'Comport Auswahl, ist kein Comport eingestellt "Connect" und "Disconnect" sperren
        If ComboBox1.SelectedItem <> "" Then
            Button1.Enabled = True
        Else
            Button1.Enabled = False
            Button2.Enabled = False
        End If

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        'Abfrage, ob das Programm wirklich beendet werden soll
        If MsgBox("Wollen Sie das Programm wirklich verlassen?", vbYesNo) = vbNo Then
            ' Falls nein: Schließen der Form durch 
            ' Setzen von e.Cancel auf True verhindern
            e.Cancel = True
            Exit Sub
        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        'Verfügbare Comports abfragen und in die Combobox schreiben
        For Each Me.port In ports
            ComboBox1.Items.Add(port)
        Next port

        'Comport bereits eingestellt?
        'Buttons freigeben oder sprerren
        If ComboBox1.Text <> "" Then
            Button1.Enabled = True
            Button2.Enabled = False
        Else
            Button1.Enabled = False
            Button2.Enabled = False
        End If

        Speed = TrackBar1.Value

    End Sub

    Private Sub Send_Command(ByVal Addr As Integer, ByVal Command1 As Integer, ByVal Command2 As Integer, ByVal Command3 As Integer)

        'Prüfsumme berechnen mit XOR
        CRC = Addr Xor Command1 Xor Command2 Xor Command3

        'Comport offen? Ja dann senden!
        If SerialPort1.IsOpen = True Then
            Control.CheckForIllegalCrossThreadCalls = False
            SerialPort1.DiscardOutBuffer()
            SerialPort1.Write(Chr(Addr) & Chr(Command1) & Chr(Command2) & Chr(Command3) & Chr(CRC) & Chr(13))
        End If

    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived

        'RS232 Daten Empfang
        Control.CheckForIllegalCrossThreadCalls = False
        Buffer = (SerialPort1.ReadExisting)
        TextBox1.AppendText(Buffer)

    End Sub


    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        'Comport verbinden
        Try
            'Auswahl der Combobox übernehmen und Schnittstelle öffnen, darauf gleich Status vom BOT abfragen
            SerialPort1.PortName = ComboBox1.Text
            SerialPort1.BaudRate = 2400
            SerialPort1.Encoding = System.Text.Encoding.Default
            SerialPort1.Open()

            TextBox1.Text = ""

            'Buttons setzen
            Button1.Enabled = False
            Button2.Enabled = True
            ComboBox1.Enabled = False

        Catch ex As Exception

            'Info wenn ein Schnittstellenfehler aufgetretten ist und Buttons setzen
            MessageBox.Show("Schnittstellen Fehler! " + e.ToString _
                       , "Exception error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Button1.Enabled = True
            Button2.Enabled = False
            ComboBox1.Enabled = True

        End Try
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        'Schnittstelle schließen und Buttons setzen
        Sleep(500)
        Send_Command(Robo_Addr, 4, 1, 2)
        Sleep(250)
        Button1.Enabled = True
        Button2.Enabled = False
        ComboBox1.Enabled = True
        SerialPort1.Close()

    End Sub

    Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.Scroll

        'Geschwindigkeitsregler
        Speed = TrackBar1.Value

    End Sub

    Private Sub Button3_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button3.MouseDown
        Send_Command(Robo_Addr, 1, 1, Speed)
    End Sub

    Private Sub Button3_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button3.MouseUp
        Send_Command(Robo_Addr, 1, 255, 0)
    End Sub

    Private Sub Button7_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button7.MouseDown
        Send_Command(Robo_Addr, 1, 2, Speed)
    End Sub

    Private Sub Button7_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button7.MouseUp
        Send_Command(Robo_Addr, 1, 255, 0)
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Send_Command(Robo_Addr, 1, 255, 0)
    End Sub

    Private Sub Button4_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button4.MouseDown
        Send_Command(Robo_Addr, 1, 4, Speed)
    End Sub

    Private Sub Button4_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button4.MouseUp
        Send_Command(Robo_Addr, 1, 255, 0)
    End Sub

    Private Sub Button6_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button6.MouseDown
        Send_Command(Robo_Addr, 1, 3, Speed)
    End Sub

    Private Sub Button6_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button6.MouseUp
        Send_Command(Robo_Addr, 1, 255, 0)
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        TextBox1.Clear()
        Send_Command(Robo_Addr, 4, 1, 0)
        TextBox1.Clear()
        Sleep(500)
        TextBox1.Clear()
    End Sub
End Class
